; on represente un arbre binaire comme une liste (etiquette fg fd)
; les feuilles sont des objets non listes

(define make-arbre
  (lambda (etiquette fg fd)
    (list etiquette fg fd)))

(define etiquette
  (lambda (a)
    (car a)))

(define fg
  (lambda (a)
    (cadr a)))

(define fd
  (lambda (a)
    (caddr a)))

(define feuille?
  (lambda (o)
    (not (list? o))))

(define arbre?
  (lambda (o)
    (or (feuille? o)
	(and (list? o)
	     (arbre? (fg o))
	     (arbre? (fd o))
	     (null? (cdddr o))))))

(define a1 (make-arbre 1 2 3))
(arbre? a1)
(define a2 (make-arbre 4 a1 a1))
(arbre? a2)
(define a3 (make-arbre 5 a1 a2))

(define hauteur
  (lambda (a)
    (if (feuille? a)
	1
	(+ 1 (max (hauteur (fg a)) (hauteur (fd a)))))))

(hauteur a2)

(define nb-feuilles
  (if (feuille? a)
      1
      (+ (nb-feuilles (fg a)) (nb-feuilles (fd a)))))

(nb-feuilles a3)

(define nb-noeuds
  (if (feuille? a)
      1
      (+ 1 (nb-noeuds (fg a)) (nb-noeuds (fd a)))))

(nb-noeuds a3)

(define parcours-profondeur
  (lambda (a)
    (if (feuille? a)
	(list a)
	(append (parcours-profondeur (fg a))
		(list (etiquette a))
		(parcours-profondeur (fd a))))))

(parcours-profondeur a3)

(define recherche
  (lambda (e a)
    (if (feuille? a)
	(eqv? e a)
	(or (eqv? e (etiquette a))
	    (recherche e (fg a))
	    (recherche e (fd a))))))

(recherche 2 a3)
(recherche 6 a3)

(define valeur-racine
	  (lambda (a)
	    (if (feuille? a)
		a
		(etiquette a))))

(define fils
	  (lambda (a)
	    (if (feuille? a) '() (list (fg a) (fd a)))))

(define parcours-largeur
  (lambda (a)
    (letrec
	((racines
	  (lambda (l)
	    (if (null? l)
		'()
		(cons (valeur-racine (car l)) (racines (cdr l))))))
	 (liste-fils
	  (lambda (l)
	    (if (null? l)
		'()
		(append (fils (car l)) (liste-fils (cdr l))))))
	 (parcours
	  (lambda (l)
	    (if (null? l)
		'()
		(append (racines l) (parcours (liste-fils l)))))))
      (parcours (list a)))))

(parcours-largeur a3)

(define parcours-largeur2
  (lambda (a)
    (letrec
	((parcours
	  (lambda (l)
	    (if (null? l)
		'()
		(cons (valeur-racine (car l))
		      (parcours (append (cdr l) (fils (car l)))))))))
      (parcours (list a)))))

(parcours-largeur2 a3)

(define print-arbre
  (lambda (a)
    (letrec
	((ecrit-atome 
	  (lambda (dec dir f)
	    (cond 
	     ((= 0 dec)
	      (begin
		(write f)
		(newline)))
	     ((= 1 dec)
	      (begin
		  (if (eqv? 'd dir)
		      (display " /--")
		      (display " \\--"))
		  (ecrit-atome 0 dir f)))
	     (else (begin
		     (display "    ")
		     (ecrit-atome (- dec 1) dir f))))))
	 (ecrit 
	  (lambda (dec dir a)
	    (if (arbre? a)
		(if (feuille? a)
		    (ecrit-atome dec dir a)
		    (begin
		      (ecrit (+ 1 dec) 'd (fd a))
		      (ecrit-atome dec dir (etiquette a))
		      (ecrit (+ 1 dec) 'g (fg a))))
		(ecrit-atome "erreur")))))
      (ecrit 0 '() a))))

(print-arbre a3)

